import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsProductSpecValue, CmsProductSpecValueParam } from './model';


/**
 * 分页查询规格值
 */
export async function pageCmsProductSpecValue(params: CmsProductSpecValueParam) {
  const res = await request.get<ApiResult<PageResult<CmsProductSpecValue>>>(
    '/cms/cms-product-spec-value/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询规格值列表
 */
export async function listCmsProductSpecValue(params?: CmsProductSpecValueParam) {
  const res = await request.get<ApiResult<CmsProductSpecValue[]>>(
    '/cms/cms-product-spec-value',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加规格值
 */
export async function addCmsProductSpecValue(data: CmsProductSpecValue) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-product-spec-value',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改规格值
 */
export async function updateCmsProductSpecValue(data: CmsProductSpecValue) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-product-spec-value',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除规格值
 */
export async function removeCmsProductSpecValue(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-product-spec-value/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除规格值
 */
export async function removeBatchCmsProductSpecValue(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-product-spec-value/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询规格值
 */
export async function getCmsProductSpecValue(id: number) {
  const res = await request.get<ApiResult<CmsProductSpecValue>>(
    '/cms/cms-product-spec-value/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
